import { BaseArrayFragment } from 'protractor-element-extend';
import { Fragment } from './fragment.wrapper';
import { promise as wdpromise } from 'selenium-webdriver';
export declare class ArrayFragment<T extends Fragment> extends BaseArrayFragment<T> {
    filter(filterFn: (elementFinder?: T, index?: number) => boolean | wdpromise.Promise<boolean> | Promise<boolean>): this;
    find(filterFn: (elementFinder?: T, index?: number) => boolean | wdpromise.Promise<boolean> | Promise<boolean>): Promise<T>;
    /**
     *
     * Represents the ArrayFragment as an array of Fragments.
     *
     * @returns {Array<Fragment>} Returns a promise, which resolves
     * to a list of Fragments.
     */
    asFragments(): Promise<Array<T>>;
    map(mapFn: (elementFinder?: T, index?: number) => any): wdpromise.Promise<Array<any>>;
    reduce(reduceFn: (value?: any, elementFinder?: T, index?: number, arr?: any) => any, initialValue: any): wdpromise.Promise<any>;
    each(fn: (elementFinder?: T, index?: number) => any): wdpromise.Promise<any>;
    private makeFnSequential;
}
