"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const protractor_1 = require("protractor");
const oi_verify_1 = require("oi-verify");
const predicates_1 = require("./predicates");
class WaitConditions {
    static clickable(element) {
        return __awaiter(this, void 0, void 0, function* () {
            yield oi_verify_1.waitFor(protractor_1.ExpectedConditions.elementToBeClickable(element), `${element.locator()} was expected to be clickable`, 20 * 1000);
        });
    }
    static visible(element) {
        return __awaiter(this, void 0, void 0, function* () {
            yield oi_verify_1.waitFor(protractor_1.ExpectedConditions.visibilityOf(element), `${element.locator()} was expected to be visible`, 20 * 1000);
        });
    }
    static invisible(element) {
        return __awaiter(this, void 0, void 0, function* () {
            yield oi_verify_1.waitFor(protractor_1.ExpectedConditions.invisibilityOf(element), `${element.locator()} was expected to be invisible`, 20 * 1000);
        });
    }
    static arrayIsNotEmpty(array) {
        return __awaiter(this, void 0, void 0, function* () {
            yield oi_verify_1.waitFor(predicates_1.Predicates.isArrayNotEmpty(array), 'Array of fragments expected to be not empty', 20 * 1000);
        });
    }
}
exports.WaitConditions = WaitConditions;
//# sourceMappingURL=wait-conditions.js.map